﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;  // SerialPort.GetPortNames()を使うために追加

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        uint T1CNT = 0;
        int  RPM=0,AIR=0,O2=0;
        int IGT=0, IGL=0;
        public Form1()
        {
            InitializeComponent();

            try
            {
                comboBox1.Items.AddRange(SerialPort.GetPortNames());    // 有効なシリアルポート一覧を取得してコンボボックスにセット
                comboBox1.SelectedIndex = 0;
            }
            catch
            {
                button1.Enabled = false;    //例外が発生した（シリアルポートがない）時、ボタンを押せなくする
            }

        }

                private void button1_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == false)    // オープン済みじゃないか調べる
            {
                serialPort1.PortName = (string)comboBox1.SelectedItem;
                serialPort1.BaudRate = 19200;
                serialPort1.DataBits = 8;              // 8ビット
                serialPort1.Parity = Parity.None;      // パリティ無し
                serialPort1.StopBits = StopBits.One;
                serialPort1.RtsEnable = Enabled;       // RTC/DTR 端子の状態をセット？
                serialPort1.DtrEnable = Enabled;
                serialPort1.Handshake = Handshake.None;    // ハンドシェイク無し
                //serialPort1.ReadTimeout = 1000;         // タイムアウト ms

                serialPort1.Open();
                button1.Text = "切断";

                serialPort1.Write("i");
                vScrollBar1.Value = vScrollBar1.Maximum;
                vScrollBar2.Value = vScrollBar2.Maximum;
                vScrollBar3.Value = vScrollBar3.Maximum;

                timer1.Interval = 100;   // タイマーの間隔をセット
                timer1.Enabled = Enabled;   // タイマースタート
            }
            else
            {
                serialPort1.Close();        // オープン済みならクローズ
                timer1.Enabled = false;   // タイマーストップ
                button1.Text = "接続";
            }
        }

                private void timer1_Tick(object sender, EventArgs e)
        {
            T1CNT++;
            if (serialPort1.IsOpen == true)    // オープン済みじゃないか調べる
            {
                if ((T1CNT & 1) == 0)
                {
                    if (vScrollBar1.Value != RPM)
                    {
                        // 値が変更されていた
                        if (vScrollBar1.Value > vScrollBar1.Maximum - 200) vScrollBar1.Value = vScrollBar1.Maximum;
                        RPM = vScrollBar1.Value;
                        if (RPM == vScrollBar1.Maximum) serialPort1.Write("i");
                        else serialPort1.Write("r" + (vScrollBar1.Maximum - RPM).ToString("D4"));
                    }
                    if (vScrollBar2.Value != AIR)
                    {
                        // 値が変更されていた
                        if (vScrollBar2.Value > vScrollBar2.Maximum - 10) vScrollBar2.Value = vScrollBar2.Maximum;
                        AIR = vScrollBar2.Value;
                        serialPort1.Write("a" + (AIR).ToString("D3"));
                    }
                    if (vScrollBar3.Value != O2)
                    {
                        // 値が変更されていた
                        O2 = vScrollBar3.Maximum - vScrollBar3.Value;
                        serialPort1.Write("b"+O2.ToString("D3"));
                        label19.Text = string.Format("O2 {0}",O2);
                    }
                    if (RPM == vScrollBar1.Maximum)
                    {
                        vScrollBar2.Value = vScrollBar2.Maximum;
                        vScrollBar3.Value = vScrollBar3.Maximum;
                    }
                }
                else
                {
                    serialPort1.Write("s");
                }


            // シリアルポート受信
                /*while (true)
                {
                    if (serialPort1.BytesToRead == 0) break;
                    textBox1.Text += (char)serialPort1.ReadByte();
                }*/

                while (true)
                {
                    string str;
                    int a;

                    if (serialPort1.BytesToRead < 9) break;    // バッファに9文字以下なら終了 (RPM:00000 で1データ9文字)

                    a = serialPort1.ReadByte();
                    if (a == 'R')
                    {
                        a = serialPort1.ReadByte();
                        if (a == 'P')
                        {
                            a = serialPort1.ReadByte();
                            a = serialPort1.ReadByte();
                            str = "";
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            if (int.TryParse(str, out a))
                            {
                                label8.Text = a.ToString("D4") + " RPM";
                                progressBar1.Value = a;
                                //textBox1.Text += label8.Text;
                            }
                        }
                    }

                    if (a == 'A')
                    {
                        a = serialPort1.ReadByte();
                        if (a == 'I')
                        {
                            a = serialPort1.ReadByte();
                            a = serialPort1.ReadByte();
                            str = "";
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            if (int.TryParse(str, out a))
                            {
                                if (a < 15) a = 0;
                                label9.Text = a.ToString("D3");
                                progressBar2.Value = progressBar2.Maximum - a;
                            }
                        }
                        if (a == 'N')
                        {
                            a = serialPort1.ReadByte();
                            if (a == '2')
                            {
                                a = serialPort1.ReadByte();
                                str = "";
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                if (int.TryParse(str, out a))
                                {
                                    a = (a & 0xff00) >> 8;
                                    label15.Text = a.ToString("D3");
                                    progressBar6.Value = a;
                                }
                            }
                            if (a == '3')
                            {
                                a = serialPort1.ReadByte();
                                str = "";
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                if (int.TryParse(str, out a))
                                {
                                    a = (a & 0xff00) >> 8;
                                    label16.Text = a.ToString("D3");
                                    progressBar7.Value = a;
                                }
                            }
                        }
                    }

                    if (a == 'I')
                    {
                        a = serialPort1.ReadByte();
                        if (a == 'N')
                        {
                            a = serialPort1.ReadByte();
                            a = serialPort1.ReadByte();
                            str = "";
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            str += (char)serialPort1.ReadByte();
                            if (int.TryParse(str, out a))
                            {
                                a = a * 32 / 10; // a*3.2us
                                label12.Text = a.ToString("D5") + " us";
                                if (a > progressBar5.Maximum) progressBar5.Value = progressBar5.Maximum;
                                else progressBar5.Value = a;
                            }
                        }
                        if (a == 'G')
                        {
                            a = serialPort1.ReadByte();
                            if (a == 'T')   // タイミング
                            {
                                a = serialPort1.ReadByte();
                                str = "";
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                if (int.TryParse(str, out a))
                                {
                                    a = a * 32 / 10;
                                    IGT = a;
                                    label10.Text = a.ToString("D5") + " us";
                                    if (a > progressBar3.Maximum) progressBar3.Value = progressBar3.Maximum;
                                    else progressBar3.Value = a;
                                }
                            }
                            if (a == 'L')   // パルス幅
                            {
                                a = serialPort1.ReadByte();
                                str = "";
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                str += (char)serialPort1.ReadByte();
                                if (int.TryParse(str, out a))
                                {
                                    a = a * 32 / 10;
                                    IGL = a;
                                    label11.Text = a.ToString("D5") + " us";
                                    if (a > progressBar4.Maximum) progressBar4.Value = progressBar4.Maximum;
                                    else progressBar4.Value = a;
                                }
                            }
                        }
                    }

                    int temp1, temp2;
                    if (progressBar1.Value > 0)
                    {
                        temp1 = (30 * 1000000 / progressBar1.Value);   // クランク1/2回転の時間[ns]
                        temp2 = temp1 / 180;            // クランクが1度回る時間
                        a = (((temp1 + 10 * temp2) - (IGL + IGT)) / temp2);
                        if (a < progressBar8.Maximum && a > 0) progressBar8.Value = a;
                        label18.Text = "BTDC " + a.ToString("D2");
                    }
                }
            }
        }
    }
}
